/*
*  To access Dll functions via GEBE_PrinterOnline(L"GEBE0:") do the following:
*
*  #include "GebeMonitorAPI.h"
*  Add gebemonitor.lib to Project settings
*  
*/

#ifndef TOOLS
#define TOOLS

#include <windows.h>

// -------------------------------
// typedef to handle dll functions
// -------------------------------
typedef bool (WINAPI *GebeRequest)(LPWSTR); 
GebeRequest Request; 

typedef bool (WINAPI *GebeStatus)(LPWSTR, enum PrinterParameter p); 
GebeStatus Status; 

// ----------------------------------------
// readThread to request the printer status
// ----------------------------------------
void RequestThread(LPVOID v){
	HMODULE m_hmodule;
	ptrCont *con=(ptrCont*)v;

	//VOID *pointer;

	m_hmodule = LoadLibrary(TEXT("gebeportmon.dll"));	
	Request = (GebeRequest)GetProcAddress(m_hmodule, TEXT("GEBE_Request"));
	Status = (GebeStatus)GetProcAddress(m_hmodule, TEXT("GEBE_Status"));
	
	do{
		if(Request(L"GEBE0:"))
		{
			if(Status(L"GEBE0:",PrinterOnline))
			{
				if(Status(L"GEBE0:",PaperEnd))
					con->edit->SetWindowText("Paper end");
				else
					con->edit->SetWindowText("Printer ok");
			}
			else
				con->edit->SetWindowText("Port ok, but offline");
		}
		else
			con->edit->SetWindowText("Wrong port");
		
		con->edit->RedrawWindow();
		Sleep(500);
	}while(con->button->GetCheck());
}

#endif